#!/usr/bin/python
#Programmed by Daniel Fernandez
#http://mechanicalforex.com
#https://asirikuy.com
#Follow me on twitter @asirikuy

import subprocess
import sys
import linecache
from tempfile import mkstemp
from shutil import copy
from os import remove
from os import rename
from datetime import datetime
import argparse
import pandas as pd
import csv
import os
import re

def lastValue(x):
    try:
        reply = x[-1]
    except:
        reply = None
    return reply

def tryint(s):
    try:
        return int(s)
    except:
        return s

def alphanum_key(s):
    """ Turn a string into a list of string and number chunks.
        "z23a" -> ["z", 23, "a"]
    """
    return [ tryint(c) for c in re.split('([0-9]+)', s) ]

def sort_nicely(l):
    """ Sort the given list in the way that humans expect.
    """
    l.sort(key=alphanum_key)

def main():

    indir = './bcktest'
    backtestFileList = []
    backtestFiles = ""
    for root, dirs, filenames in os.walk(indir):
        for f in filenames:
            if "sys" in f:
                backtestFileList.append("bcktest/" + f)
            
    sort_nicely(backtestFileList)

    j = 0

    for item in backtestFileList:
    
        print item

        tradeTimes = []
        tradeBalance = []
        
        with open(item, 'rb') as csvfile:
            reader = csv.reader(csvfile)
            i = 0
            for row in reader:
                if i > 0:
                    tradeTimes.append(datetime.strptime(row[3], '%d/%m/%Y %H:%M'))
                    tradeBalance.append(float(row[10]))
                i += 1

        if j == 0:
            allTimeSeries = pd.Series(data=tradeBalance, index=tradeTimes).resample('M', how=lastValue).pct_change(fill_method='pad').fillna(0)
        else:
            allTimeSeries = pd.concat([allTimeSeries, pd.Series(data=tradeBalance, index=tradeTimes).resample('M', how=lastValue).pct_change(fill_method='pad').fillna(0)], axis=1)
  
  
        j += 1
    
    allTimeSeries = allTimeSeries.fillna(0)
    
    all_RCI = []
    
    for i in range(len(allTimeSeries.columns)):
    
        RCI_values = []
        returns1 = allTimeSeries.iloc[:,i]
                
        for j in range(len(allTimeSeries.columns)):
            returns2 = allTimeSeries.iloc[:,j]
            if i != j:
                rolling_correlations = pd.rolling_corr(arg1=returns1, arg2=returns2, window=6).dropna()
                RCI = (rolling_correlations > 0.5).sum()
                print "index is {}".format(RCI)
                RCI_values.append(RCI)
            else:
                RCI_values.append(0.0)
            
        all_RCI.append(RCI_values)
                
    
    correlations = pd.DataFrame(all_RCI)    
            
    import matplotlib.pyplot as plt
    fig, ax = plt.subplots(figsize=(12,9), dpi=100)
    heatmap = ax.matshow(correlations, aspect = 'auto', origin = 'lower', cmap ="RdYlBu")

    ax.invert_yaxis()
    ax.xaxis.tick_top()

    plt.show()


            
##################################
###           MAIN           ####
##################################

if __name__ == "__main__": main()
